package com.testsound;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.PowerManager;
import android.os.PowerManager.WakeLock;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Toast;
import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import lib.jgraph.AndroidJGraph;
import lib.jgraph.Color;

public class MainActivity extends Activity {

    Button startR;
    Button stop;
    Button detail;
    Button zoom;
    LinearLayout layout;
    boolean stopC = true;
    Capture capt;
    Tache1 t1 = new Tache1();
    private Thread th;
    AndroidJGraph jGraph;
    byte[] point = null;
    double[] courbe = null;
    double[] y = null;
    double periode = (1.0 / 44100.0);
    List<double[]> liste = new ArrayList<double[]>();
    private WakeLock WakeLock;
    

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        final PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);//bloque la mise en veille
        this.WakeLock = pm.newWakeLock(PowerManager.SCREEN_DIM_WAKE_LOCK, "My Tag");
        this.WakeLock.acquire();


        this.layout = (LinearLayout) findViewById(R.id.linearLayout);
        this.startR = (Button) findViewById(R.id.buttonStart);
        this.stop = (Button) findViewById(R.id.buttonStop);
        this.detail = (Button) findViewById(R.id.buttonDetail);
        this.zoom = (Button) findViewById(R.id.buttonZoomReset);
        jGraph = new AndroidJGraph(MainActivity.this);
        this.layout.addView(jGraph);

        this.startR.setOnClickListener(clickStart);
        this.detail.setOnClickListener(clickDetail);
        this.stop.setOnClickListener(clickStop);
        this.zoom.setOnClickListener(clickZoomReset);

    }

    @Override
    public void onDestroy() {
        this.WakeLock.release();// ne pas oublier de remettre la mise en veille en route lors de la fermeture de l'application
        super.onDestroy();
    }
    private OnClickListener clickStart = new OnClickListener() {
        @Override
        public void onClick(View arg0) {
            if (stopC == true) {
                capt = new Capture();
                stopC = false;
                capt.setStopCapture(stopC);
                capt.startCapture();
                th = new Thread(t1);
                th.start();
            }
        }
    };
    private OnClickListener clickStop = new OnClickListener() {
        @Override
        public void onClick(View arg0) {
            if (stopC == false) {
                stopC = true;
                capt.setStopCapture(stopC);
            }
        }
    };
    private OnClickListener clickDetail = new OnClickListener() {
        public void onClick(View view) {
            if (!liste.isEmpty()) {
                int b = 0;
                
                double[] copy;
                courbe = new double[44100 * liste.size()];
                double[] courbeFiltre = new double[courbe.length];
                for (int i = 0; i < liste.size(); i++) {
                    copy = liste.get(i);
                    for (int a = 0; a < copy.length; a++) {
                        courbe[b] = copy[a];
                        b++;
                    }
                }
                courbeFiltre = OrderTwoFilters.highPassFilter(courbe, 1000, 44100);
                y = new double[courbe.length];
                for (int i = 0; i < courbe.length; i++) {
                    y[i] = periode * i;
                }
                jGraph.removeGraphs();
                jGraph.addGraph("Sound", y, courbe);
                jGraph.addGraph("filtre", y, courbeFiltre);
                jGraph.setGraphColor("filtre", Color.red);
                jGraph.setZoomOutLimit();
            } else {
                Toast.makeText(getApplicationContext(), "aucun enregistrement", Toast.LENGTH_LONG);
            }
        }
    };
    private OnClickListener clickZoomReset = new OnClickListener() {
        public void onClick(View view) {
            jGraph.zoomToScaleOne();
        }
    };

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }

    public class Tache1 implements Runnable {

        PipedInputStream pIStream;
        PipedOutputStream pos;

        /**
         * consommateur
         */
        @Override
        public void run() {

            point = new byte[capt.bufferSize];

            double[] x = null;
            double[] copy = null;
            

            byte n1;
            byte n2;

            int time = 0;
            liste.removeAll(liste);
            pos = capt.getSender();

            pIStream = new PipedInputStream(capt.bufferSize * 10);
            try {
                pIStream.connect(pos);
            } catch (IOException ex) {

                Logger.getLogger(MainActivity.class.getName()).log(Level.SEVERE, null, ex);
            }
            jGraph.removeGraphs();
            while (stopC == false) {
                int offset = 0;
                while (offset < point.length) {

                    try {
                        offset += pIStream.read(point, offset, point.length - offset);
                    } catch (IOException ex) {
                        Logger.getLogger(MainActivity.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }

                x = new double[capt.bufferSize / 2];

                for (int i = 0, i2 = 0; i < x.length; i++) {
                    n1 = point[i2]; // 00 ff  , 0 7f 80 ff80
                    n2 = point[i2 + 1];
                    i2 = i2 + 2;
                    x[i] = (n1 & 0xff) | (n2 << 8);
                }

                if (liste.size() == 10) {
                    liste.remove(0);
                }
                liste.add(x);
                int b = 0;
                courbe = new double[x.length * liste.size()];
                for (int i = 0; i < liste.size(); i++) {
                    copy = liste.get(i);
                    for (int a = 0; a < copy.length; a++) {
                        courbe[b] = copy[a];
                        b++;

                    }
                }
                double[] courbeFiltre = new double[x.length];
                courbeFiltre = OrderTwoFilters.highPassFilter(x, 1000, 44100);

                y = new double[x.length];
                for (int i = 0; i < y.length; i++) {

                    y[i] = periode * time;
                    time++;
                }
                jGraph.addGraph("Sound", y, x); 
                jGraph.addGraph("filtre", y, courbeFiltre);
                jGraph.setGraphColor("filtre", Color.red);
                
                jGraph.setZoomOutLimit();
            }
        }
    }
}
